with text_io;
use text_io;
procedure Hello is
begin
  put_line("Hello, World!");
end Hello;

-----------------------------------------------------------------

with TEXT_IO; use TEXT_IO;
procedure ADD is
   package MY_INT_IO is new INTEGER_IO(INTEGER); use MY_INT_IO;
begin
   PUT(2 + 2);
   NEW_LINE;
end ADD;

-----------------------------------------------------------------

with text_io; 
use text_io;

procedure simple is
	package MY_INT_IO is new INTEGER_IO(INTEGER); use MY_INT_IO;
begin
	for i in 1..10 loop
		put(i);
		put(' ');
        new_line;
	end loop;
	new_line;
end;

-----------------------------------------------------------------

--tisk obrazku pomoci importovane procedury t, z kompilacni jednotky NIC.ADA

with nic; 
use nic;

procedure nicnic is
begin
  t;
  t;
  t;
end nicnic;

-----------------

--tiskne obrazek, exportovanou procedurou t, pouzitou v rodicovske
--kompilacni jednotce NICNIC.ADA

with text_io; 
use text_io;


package nic is
   procedure t;
end nic;


package body nic is

	procedure t is
 	  tot:integer:=1;
   	  package int_io is new integer_io(integer);
   	  use int_io;
    begin
      new_line;
   	  put("Kolik hlav ma mit totem ? ");
      get(tot);
      new_line;
   	  put_line("--------------------------------------------------------------");
      new_line;
   	  new_line;
   	  for f in 1..tot loop
     	put_line("  (((||)))");
    	put_line("  (*)++(*)");
   	    put_line("     ..   ");
  	    put_line("   ------");
      end loop;
      new_line;
   	  put_line("--------------------------------------------------------------");
	end t;
end nic;

-----------------------------------------------------------------

with text_io, MyPack;
use  text_io, MyPack;
          
procedure hlavni is
    i: character;
begin
    get(i);
    if JeVelke(i) then
        put_line("Je velke");
    else    
        put_line("Neni velke");
    end if;
end hlavni;

----------------

package MyPack is
    function JeVelke(vstup:character) return boolean;
end MyPack;        
        
package body MyPack is
    function JeVelke (vstup : character) return boolean is
    begin
        return vstup in 'A'..'Z';
    end JeVelke;
end MyPack;

-----------------------------------------------------------------

with text_io;
use text_io;

procedure hlavni is
    i: character;
    function JeVelke (vstup : character) return boolean is
	begin
 	   return vstup in 'A'..'Z';
	end JeVelke;

begin
    text_io.get(i);
    if JeVelke(i) then
        put_line("Je velke");
    else    
        put_line("Neni velke");
    end if;
end hlavni;

-----------------------------------------------------------------

-- Vypocet korenu kvadraticke rovnice
-- O. Rohlik, 2002 

with TEXT_IO;
use TEXT_IO;
with Ada.Numerics.Elementary_Functions;
use Ada.Numerics.Elementary_Functions;
    
procedure main is
  -- deklarace
  a,b,c,d,x1,x2 : FLOAT;
  package MyFloat_IO is new FLOAT_IO(FLOAT);
  use MyFloat_IO;

begin
  new_line;
  put_line("+-----------------------------------------------------+");
  put_line("| Program na vypocet korenu kvadraticke rovnice tvaru |");
  put_line("|                                                     |");
  put_line("|               a*x^2 + b*x + c = 0                   |");
  put_line("+-----------------------------------------------------+");
  new_line;
  new_line;
  put("Zadej koeficient a: ");
  get(A);
  put("Zadej koeficient b: ");
  get(B);
  put("Zadej koeficient c: ");
  get(C);
  
  D := B**2-4.0*A*C;
  new_line;
  put("( Diskriminant je: ");   
  put(D, 5, 2, 0); -- posledni tri parametry jsou jen na formatovani vystupu realneho cisla
  put(" )");   
  new_line;
  new_line;
  
  if D = 0.0 then 
    put("Existuje jedno reseni v R a to je: ");   
    put(-B/(2.0*A), 5, 2, 0); 
  elsif D > 0.0 then 
    put("Existuji dve reseni v R a to: ");   
    put((-B+Ada.Numerics.Elementary_Functions.sqrt(D))/(2.0*A), 5, 2, 0);
    put(" a ");   
    put((-B-sqrt(D))/(2.0*A), 5, 2, 0);
  else
    put("Neexistuje reseni v R.");       
  end if;
end main;    

-----------------------------------------------------------------

-- Vypocet korenu kvadraticke rovnice s pouzitim funkce definovane v modulu
-- O. Rohlik, 2002 

with TEXT_IO;
use TEXT_IO;
with Ada.Numerics.Elementary_Functions;
use Ada.Numerics.Elementary_Functions;
with Diskriminant;
use Diskriminant;
    
procedure main is
  -- deklarace
  a,b,c,d,x1,x2 : FLOAT;
  package MyFloat_IO is new FLOAT_IO(FLOAT);
  use MyFloat_IO;
  
  --function Disk (a,b,c:float) returns float;
  --function Disk (a,b,c:float) return float is
  --begin
  --    return B**2-4.0*A*C;
  --end;

begin
  new_line;
  put_line("+-----------------------------------------------------+");
  put_line("| Program na vypocet korenu kvadraticke rovnice tvaru |");
  put_line("|                                                     |");
  put_line("|               a*x^2 + b*x + c = 0                   |");
  put_line("+-----------------------------------------------------+");
  new_line;
  new_line;
  put("Zadej koeficient a: ");
  get(A);
  put("Zadej koeficient b: ");
  get(B);
  put("Zadej koeficient c: ");
  get(C);
  
  D := Disk(a,b,c);
  new_line;
  put("( Diskriminant je: ");   
  put(D, 1, 2, 0); -- posledni tri parametry jsou jen na formatovani vystupu realneho cisla
  put(" )");   
  new_line;
  new_line;
  
  if D = 0.0 then 
    put("Existuje jedno reseni v R a to je: ");   
    put(-B/(2.0*A), 5, 2, 0); 
  elsif D > 0.0 then 
    put("Existuji dve reseni v R a to: ");   
    put((-B+Ada.Numerics.Elementary_Functions.sqrt(D))/(2.0*A), 5, 2, 0);
    put(" a ");   
    put((-B-sqrt(D))/(2.0*A), 5, 2, 0);
  else
    put("Neexistuje reseni v R.");       
  end if;
end main;    



----------------------

-- Vypocet korenu kvadraticke rovnice - modul s funkci, ktera je pouzita v hlavnim programu
-- O. Rohlik, 2002 

package Diskriminant is 
  function Disk (a,b,c:float) return float;
end Diskriminant  ;

with Ada.Numerics.Elementary_Functions;
use Ada.Numerics.Elementary_Functions;

package body Diskriminant is    
    
  function Disk (a,b,c:float) return float is
  begin
      return B**2-4.0*A*C;
  end Disk;
  
end Diskriminant;    

-----------------------------------------------------------------